package main

import (
	"demos/ops/ml"
	"flow"
	"log"
)

func main() {

	r := ml.New()

	f := flow.New()
	f.UseRegistry(r)

	samples := [][]float64{
		{0, 0},
		{0, 1},
		{1, 0},
		{1, 1},
	}
	labels := []float64{1, 0, 0, 1}
	_ = samples
	_ = labels

	// Try binary operations first
	// 2 inputs 1 output
	// Load minst somehow 28x28 784
	nSample := 1

	// Load minst into floats array

	// Make a matrix from the weights variable
	// 5 outputs

	// Layer 1
	//
	sample := samples[nSample]

	// Define input
	// Make a matrix out of the input
	inp := f.Op("matNew", 2, 1, f.In(0))

	// Layer1 weights
	w1 := f.Op("matNew", 5, 2, f.Var("w1", f.Op("normFloat", 5*2)))

	l1op := f.Op("matSigmoid", f.Op("matMul", w1, inp))

	// 5 inputs 2 output
	w2 := f.Op("matNew", 2, 5, f.Var("w2", f.Op("normFloat", 2*5)))

	// Previous layer result
	l2op := f.Op("matSigmoid", f.Op("matMul", w2, l1op))

	// Do we need this?
	netOp := f.Op("toFloatArr", l2op)

	netResI, _ := netOp.Process(sample)
	res := netResI.([]float64)
	log.Println("Network result:", res)
	log.Println("Loss", res[0]-sample[0], res[1]-sample[1])
	// Back propagation

	//log.Println(layerRes.Process(samples[0]))

	// Operation
	/*mulRes := f.Op("matrixMul", w1, inp)
	res, _ := mulRes.Process([]float64{0, 0})

	sig := f.Op("matrixSigmoid", mulRes)

	res, _ = sig.Process(samples[0])

	log.Println("Result:", res)*/
	//f.Analyse(os.Stdout, []float64{0, 1})

	// weights

}
